/*****************************************************************************
*                                                                            *
*   Home Finance Database System.                                            *
*   Keep track of your money and have easy access to finding data.           *
*                                                                            *
*   Originally developed on Linux                                            *
*                                                                            *
*   Author: Peter Leif Rasmussen, 1996                                       *
*****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include"finance.h"

extern void time_check(struct tm *tid);
extern int check_descr(char *,opt_unit *);
extern void print_options(opt_unit *);
extern int changed,item;

void new_data(opt_unit *);

rec_unit *finance, *finance_end, *temporary;

void new_data(opt_unit *check_list)
{
int goon=0,lets_go;
char svar[10];
char temp[1000];
rec_unit *temp_point;
struct tm tid;

if(item==0)
   {
   if(!(temp_point=(rec_unit *)malloc(sizeof(rec_unit)))) 
        {fprintf(stderr,"Couldn't allocate space for finance\n");return;}
   finance=temp_point;
   }
else temp_point=finance_end;

time_check(&tid);

do{
  lets_go=0;
  do{
    printf("Please enter the year [%d]: ",tid.tm_year);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1) temp_point->year=tid.tm_year;
    else temp_point->year=atoi(temp);

    printf("Please enter the month [%d]: ",tid.tm_mon+1);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1) temp_point->month=tid.tm_mon+1;
    else temp_point->month=atoi(temp);

    printf("Please enter the day [%d]: ",tid.tm_mday);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1) temp_point->day=tid.tm_mday;
    else temp_point->day=atoi(temp);

    printf("Is this date OK? \"%d-%d-%d\"  (y/n) :  ",
            temp_point->year,temp_point->month,temp_point->day);
    fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1 || temp[0]=='y') lets_go=1;

    } while(temp_point->year>3000 || temp_point->year<1900 || temp_point->month>11 
           || temp_point->month<0 || temp_point->day>31 || temp_point->day<1
           || lets_go==0);
  do{
    printf("Enter a description (\"?\" to see approved list) : "); 
    fflush(stdout);
    fgets(temp,1000,stdin);
    if(temp[0]=='?') print_options(check_list);
    } while (check_descr(temp,check_list));

  temp_point->descr_length=strlen(temp);

  temp_point->description=(char *)calloc(temp_point->descr_length+1,1);
  if(temp_point->description==NULL) fprintf(stderr,"description malloc error, temp_point->descr_length=%d\n",temp_point->descr_length);
  strncpy(temp_point->description,temp,temp_point->descr_length-1);
  strcat(temp_point->description,"\0");

  do{
    printf("Enter the amount of cash used (0.0 - 10000.0) [0.0]: "); fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1) temp_point->cash=0.0;
    else temp_point->cash=atof(temp);
    } while(temp_point->cash<0.0 || temp_point->cash>10000.0);

  do{
    printf("Enter the amount of credit card used (0.0 - 10000.0) [0.0]: "); fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1) temp_point->credit=0.0;
    else temp_point->credit=atof(temp);
    } while(temp_point->credit<0.0 || temp_point->credit>10000.0);

  do{
    printf("Enter the amount of income (0.0 - 100000) [0.0]: "); fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1) temp_point->income=0.0;
    else temp_point->income=atof(temp);
    } while(temp_point->income<0.0 || temp_point->income>100000.0);

  temp_point->ID=item;

  item++;

  printf("\nMore Data? (y/n): ");
  fgets(svar,5,stdin);
  puts(svar);
  if((svar[0]=='N')||(svar[0]=='n')) goon=1;
  if(!(temp_point->next_rec=(rec_unit *)malloc(sizeof(rec_unit)))) 
    {fprintf(stderr,"Couldn't allocate space for temp_point->next_rec\n");return;}

  temp_point=(rec_unit *)temp_point->next_rec;

  } while(goon!=1);
finance_end=temp_point;
finance_end->next_rec=(rec_unit *)malloc(sizeof(rec_unit));

changed=1;
}
